
#define Version "190904"
// test avec HC12 Bleu et HC12 Violet
// test cde LEDR et LEDV OK
// bug corrig       cx=* (p1+3);   was  cx=* (*p1+3);
#pragma ReentrancyCheck OFF

/*
%DATE% - current system date
%TIME% - current system time
%DEVICE% - device(MCU) name as specified in project settings
%DEVICE_CLOCK% - clock as specified in project settings
%COMPILER% - current compiler version
*/

//#define Version "190901"

/*
   config bits:
CONFIG1H : $300001 : 0x0028
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x00BF
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040

 */
 
 // hardware
// power supply 3.6  5V DC
// I2C SCL sur RC3        RTC DS1307 + 24C32 + LCD4x20 + 24FC1026
// I2C SDA sur RC4        RTC DS1307 + 24C32 + LCD4x20 + 24FC1026
// TX UART1 sur RC6
// Entree Analog sur RA0 et RA1
// Sortie Led rouge sur RA4
// Entree RB0 choix init ou pas de la RTC
// TX UART1 sur RC6  --> interface 2Tr  TTL/RS232  19200,8,N,1
// RX UART1 sur RC7  <-- interface 2Tr  TTL/RS232


 // Hardware
 /*

 Pin 28 RB7  --------ICSP Data     or UART2 RX <--
 Pin 27 RB6  --------ICSP Clock    or UART2 TX -->
 Pin 26 RB5
 Pin 25 RB4
 Pin 24 RB3
 Pin 23 RB2
 Pin 22 RB1
 Pin 21 RB0                               Transceiver 433MHz
 Pin 20      VDD --------+5V  --------------  HC12 Vcc  1
 Pin 19      Vss ---------Gnd  -------------  HC12 Gnd  2
 Pin 18  RC7  RX UART  <-- Keyboard  <------  HC12 TX   3
 Pin 17  RC6  TX UART  --> Display   ------>  HC12 RX   4
 Pin 16  RC5
 Pin 15  RC4 ---- SDA   --  PCF8754  + LCD1602

 Pin 14 RC3 ----  SCL   --  PCF8754  + LCD1602
 Pin 13 RC2
 Pin 12 RC1
 Pin 11 RC0  -------------------------------> HC12 SET 5
 Pin 10 RA6  --> *option output fOSC/4
 Pin  9 RA7
 Pin  8 VSS --------- 0V  Gnd
 Pin  7 RA5
 Pin  6 RA4  Output -- Led rouge -- 2,7K --+Vcc
 Pin  5 RA3
 Pin  4 RA2 ----------> TX UART3 soft
 Pin  3 RA1  <-------OWS input
 Pin  2 RA0  <-------Analog Input EA0
 Pin  1 RE3 MCLR  Reset --------ICSP PGRM

*/


#include "built_in.h"     // for  Hi  Lo ..etc

#define FOSC_INTERNE
#define MCU "18F26K22"
#define With_UART3

#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_HC12_Transceiver_433Mhz"
#define Source "P18F26K22_Concentrateur_HC12"
#define Projet "P18F26K22_Concentrateur_HC12.mcppi"
#define Power_Supply " 3.6  5V"
#define EEPROM "non"
//"18F26K22_Test_lib_LCD_I2C1_Uart1_PCF8754_Inp_EEPROM.ihex"


#ifdef FOSC_INTERNE
#define Config "P18F26K22_FOSC_interne_16Mhz.cfgsch"
#define FOSC " 16MHz"
#else
#define Config "P18F26K22_FOSC_Q32Mhz.cfgsch"
#define FOSC "Q32MHz"
#endif

#define PCF8574_ADDR 0x4A   // PCF8574 on breadboard drives  8 leds --R--- +5V
#define DS1307_ADDR 0xD0 // RTC DS1307
#define EEPROM_32K_ADR 0xA0 // EEPROM 24LC256

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space
#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define On 0
#define Off 1


const char chaine0[]=" Directory: "Directory"\r\n";
const char chaine1[]=" Projet : "Projet "\r\n";
const char chaine2[]=" MCU  :"MCU" Alim. = "Power_Supply"\r\n";
const char chaine3[]=" Config : "Config"\r\n";
const char chaine4[]=" FOSC interne "FOSC" via " Config"\r\n";
const char chaine5[]=" Port Hard UART1 19200,N,8,1 (RC6=TX RC7=RX) \r\n";
const char chaine6[]=" RA0=ADC  RA1=OWS sensor DS18B20 \r\n";
//const char chaine6[]=" Port Hard UART2 19200,N,8,1 (RB6=TX RB7=RX) \r\n";
const char chaine7[]=" Source "Source"_"Version".c\r\n" ;
#ifdef With_UART3
const char chaine8[]=" Avec TX UART3 ASM sur RA2 output\r\n";
#else
const char chaine8[]="\r\n";
#endif
const char chaine9[]=" EEPROM non utilise\r\n";
const char chaine10[]=" Langage MikroC 7.50 \r\n";
const unsigned char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5 ,chaine6,chaine7,chaine8,chaine9,chaine10};




#define OWS_Pin  &PORTA,1
#define MAXLEN0 80
#define MAXLEN1 80
#define MAXLEN2 80

sbit Led_Verte at LATA3_bit  ;
sbit Led_Verte_Dir at TRISA3_bit  ;
sbit Led_Rouge at LATA4_bit  ;
sbit Led_Rouge_Dir at TRISA4_bit  ;
sbit HC12_SET_Pin at LATC0_bit;
sbit HC12_SET_Pin_Dir at TRISC0_bit;

#ifdef With_UART3
// la Pin de sortie est definie dans le main program
sbit TX3_Pin at LATA.B2;
sbit TX3_Pin_Dir at TRISA.B2;
unsigned char c3 absolute 0x0020;
unsigned char RS_Count absolute 0x0021;
unsigned char  RS_tmp absolute 0x0022;
unsigned char RS_Delay absolute 0x0023;
#endif


unsigned char CANAL []="AT+C010\r\n";  // CANAL du concentrateur
unsigned char FREQ[][4]={433.76,433.83,433.90,433.97};
unsigned char TEXTE[MAXLEN0];
unsigned char buffer1[MAXLEN1];
unsigned char buffer2[MAXLEN2];
volatile char  c1,c2;
volatile int DataReady1,DataReady2;
volatile unsigned int CptErr;
volatile unsigned int Count0;
volatile int CptFO1,CptFE1, CptFO2,CptFE2;
volatile int Index1,Index2,i1,i2;
volatile int erreurs;
unsigned char * txt;
unsigned char * p1,*p2;
int i,j,k,l;

char CRam1[32];
char CRam2[16];

unsigned int EA0;
volatile volatile unsigned int Count1;
volatile  unsigned int Count2;
volatile int Flag_Timer1;
volatile int Flag_Timer2;

volatile unsigned int NbCycles_T1;
unsigned int temp;unsigned char cx;
unsigned char ch=0;

#ifdef With_UART3
void UART3_Write(unsigned char c1);         // ecrit 1 char
void UART3_Write_Text(unsigned char *T);    // ecrit un texte situ en RAM
void UART3_Write_CText(const char *txt3);    // ecrit un texte en dur (situ en ROM)
void CRLF3(void) ;
#endif
void Arme_Timer1(unsigned int N);

void interrupts() iv 0x0008 ics ICS_AUTO
 {
 if((RC1IE_bit==1)&& (PIR1.RC1IF==1)) // si une interruption UART1 arrive
  {
    c1 =RCREG1; // le lire => RAZ  RCIF
    if(RCSTA1.FERR==1 )
    {
     RCSTA1.SPEN = 0 ;
     CptFE1++;
     RCSTA1.SPEN= 1 ;
     c1=0;
    }
    if (RCSTA1.OERR==1)    // voir parag 16.1.26 p273
    {
       RCSTA1.CREN = 0 ;
       RCSTA1.CREN = 1 ;
       CptFO1++;
       c1=0;
    }
     if (Flag_Timer1==1)
      {
      buffer1[i1] = 0;         //  0 a la fin du string
      DataReady1 = 1;      // drapeau Data recue
      Index1=i1;
      i1=0;
      c1=RCREG1;  // lit le LF suivant
       RC1IE_bit=0;
     }
     else
     {
      buffer1[i1] = c1;
      i1++;
      Index1=i1;
      }
     
     if (i1>MAXLEN1)
     {
      DataReady1=2;
      RC1IE_bit=0;
      buffer1[i1-2]=0;
     }
   } //if PIR1
   /*
  //------------ UART2 --------------- B7 B6 ----
  if((RC2IE_bit==1)&& (PIR3.RC2IF==1)) // si une interruption UART1 arrive
   {
    c2 =RCREG2; // le lire => RAZ  RCIF
    if(RCSTA2.FERR==1 )
     {
     RCSTA2.SPEN = 0 ;
     CptFE2++;
     RCSTA2.SPEN= 1 ;
     }
   if (RCSTA2.OERR==1)    // voir parag 16.1.26 p273
    {
       RCSTA2.CREN = 0 ;
       RCSTA2.CREN = 1 ;
       CptFO2++;
    }
   if(c2 != CR )
    {
      buffer2[i2] = c2;
      i2++;
      Index2=i2;

     }
     else
      {
      buffer2[i2] = 0;         //  0 a la fin du string
      DataReady2 = 1;      // drapeau Data recue
      Index2=i2;
      i2=0;
       RC2IE_bit=0;
     }
   if (i2>MAXLEN2)
   {
      DataReady2=2;
      RC2IE_bit=0;
      buffer2[i2-2]=0;
    }
   }
   */
    // ------  timer 1  ----------------
  if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  
      Count1--;
      // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     if (Count1<1)   // x 100mS
       {
        Count1=0;
        Flag_Timer1=1;
        TMR1IE_bit=0;
      }
      TMR1H         = 0x3C;
      TMR1L         = 0xB0;
      PIR1.TMR1IF=0;

   }

 }

 // * --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}


 void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}


void Arme_Timer1(unsigned int N)
 {
 //Prescaler 1:8; TMR1 Preload = 15536; Actual Interrupt Time : 100 ms
 // at 16Mhz
  T1CON         = 0x30; // avec TMR1ON_Bit=0
  TMR1IF_bit      = 0;
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
  Count1=N;
  Flag_Timer1=0;
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  PIE1.TMR1IE=0;  //disable interrupt TMR1
  TMR1ON_bit=1;
  TMR1IE_bit  = 1;
}


void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

void CRLF2()
{
 UART2_Write(CR);
 UART2_Write(LF);
}

void UART2_Write_CText(const char *txt)
 {
   while (*txt)
      UART2_Write(*txt++);
}


void Raz_Buffer1()
{  int i;
        // nettoye le debut de buffer ,car utilis pour init BT
        for(i=0;i<MAXLEN1-1;i++) buffer1[i]=0;
        c1=RCREG1;
        buffer1[0]=0;
        c1=0;
        i1=0;
        Index1=0;
        DataReady1 =0 ;
        RC1IE_bit = 1;
}

void Presentation()
{
 for (i=0;i<10;i++)
  {
  #ifdef With_UART3
    UART3_Write_CText(RS_Str[i]);
    #else
     UART1_Write_CText(RS_Str[i]);
    #endif
    Delay_ms(300);
    }

}



char  DS18B20_Build_value(unsigned int temp2write)
 {
 int jj;
 const unsigned int RES_SHIFT =4;  //  economie de 1 byte  en supprimant  TEMP_RESOLUTION (- 8);
  unsigned char temp_whole;
  unsigned int temp_fraction;
  char Signe=0;
  // Check if temperature is negative
    // Check if temperature is negative
  if (temp2write & 0x8000) {
     Signe=1  ;
      TEXTE[0] = '-';
     temp2write = ~temp2write + 1;
     }
     else
     {
     Signe=0;
    TEXTE[0] = ' ';
     }
  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  // Convert temp_whole to characters
  TEXTE[1] = (temp_whole/10)%10 + 48;             // Extract tens digit
  if (TEXTE[1]=='0')TEXTE[1]=' ';
  TEXTE[2] =  temp_whole%10     + 48;             // Extract ones digit
  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  temp_fraction *= 625;
   TEXTE[3]='.';
  // Convert temp_fraction to characters
  TEXTE[4] =  temp_fraction/1000    + 48;         // Extract thousands digit
  TEXTE[5] = (temp_fraction/100)%10 + 48;         // Extract hundreds digit
  TEXTE[6] =0;// (temp_fraction/10)%10  + 48;         // Extract tens digit
  TEXTE[7]= 0; //temp_fraction%10      + 48;         // Extract ones digit
  TEXTE[8]=0;
  Ltrim(TEXTE+1);
 /*
 if (Signe==1)
  DS18B20_Temp1= ( temp_whole *1000) +temp_fraction  ;
  else
   DS18B20_Temp1= -(( temp_whole *1000) +temp_fraction  );
   */
   return Signe  ;
 }
 

void Init_Hardware()
{

  PORTA = 0x00;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  TRISA = 0b00100011 ;   // RA01= analog input  RA1=OWS sensor  RA2=output=UARTX3  RA4=output
  Led_Rouge_Dir=0;
  Led_Rouge=Off;
   Led_Verte_Dir=0;
  Led_Verte=Off;
  TX3_Pin_Dir=0;
  TX3_Pin=1;

  ANSELB=0;
  PORTB = 0xFF;
  TRISB = 0x8F;    //  B0..B3 input   ATTENTION B7 B6 for ICSP Pickit3
  INTCON2.RBPU=0;      // enable Pull-up


  ANSELC=0;
  PORTC = 0x00;          // RC0..RC6 = Output    RC7 =input
  TRISC = 0xFF;    //
//  TRISC.TRISC3 = 1;  // SCL I2C
 // TRISC.TRISC4 = 1;  // SDA I2C
//  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  TRISC.TRISC1 = 0;  // output to BT HC06 reset
  HC12_SET_Pin_Dir=0;
  HC12_SET_Pin=1;
  SLRCON=0; // standard rate for PORTA,B,C,E


 }

 #ifdef With_UART3
  #include "UART3.inc"
 #endif



void main()
{
 #ifdef FOSC_INTERNE
  //OSCTUNE=0;
  // OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz
  // OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz
  // OSCTUNE.PLLEN=0    ;
  // 8MHz  x4 => 32MHz
   OSCTUNE=0;
  // OSCCON = 0b01100000  ; //0x60 ;     //Oscillateur  8Mhz si usage PLL
  // OSCCON = 0b01110000  ; //0x70 ;     //Oscillateur  16Mhz si usage PLL
   OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz SANS PLL
   OSCTUNE.PLLEN=0    ;   // 1= avec PLL => 64Mhz    0 =sans PLL => 16Mhz
   OSCCON2=0;
   while (OSCCON.HFIOFS==0); // wait stable oscillator
   #else
   // Q=8Mhz  x PLL
   #endif

   Init_Hardware();
   
      // init des variables specifiques  UART3
   c3=0;
   RS_Count=0;
   RS_tmp =0;
   RS_Delay=0;
   CRLF3();
   
   for (i=0;i<4;i++)
   {
    Led_Verte=On;
    Led_Rouge=Off;
    Delay_ms(300);
       Led_Verte=Off;
    Led_Rouge=On;
    Delay_ms(300);
    }
    
    Led_Verte=Off;
    Led_Rouge=On;


   erreurs=0;
   CptFO1=0;
   CptFE1=0;
  // CptFO2=0;
  // CptFE2=0;
   CptErr=0;


   RCSTA=0;
   RCSTA.CREN=1;  //enable receiver
   RCSTA.SPEN=1;  // serial port Pins Enable
   RCSTA.SREN=1;  // single bit receive
   Count0=0;
   
   WUE_bit = 1;

   c1=0;

   Led_Rouge=0;
   txt=TEXTE;
   UART1_Init(9600);  // Initalize USART
   Delay_ms(200);


   
   Presentation() ;
   TX3_Pin=0;
   CRLF3();
   
   UART3_Write_CText(" Init I2C1 400Khz\r\n");
   I2C1_Init(400000); // Initialisation de l'I2C
   Delay_ms(500);

   UART3_Write_CText(" IT UART1 RC6 & Timer1\n\r");
   CRLF3();
   
   PIE1.TMR1IE=1;  // Enable interrupt on PR1=TMR1
   PIE1.RCIE=1 ; // autorise IT Reception UART
   INTCON.PEIE=1;  // autorise IT des peripherique voir fig  8.1 p 77
   INTCON.GIE=1;   // Enable all interrupts (timer1 & UART)



     UART3_Write_CText(" Init Setting  Canal 10 mode  FU3 ");

         HC12_SET_Pin=0;
         Delay_ms(500);
       //  UART1_Write_CText("AT+B9600\r\n");
      //   Delay_ms(100);
         UART1_Write_CText("AT+C010\r\n");
         Delay_ms(100);
         UART1_Write_CText("AT+FU3\r\n");
         Delay_ms(100);
         // lecture config    
         UART3_Write_CText("\r\n Lecture Setting  HC12 concentrateur sur Base PIC\r\n ");
         UART3_Write_CText("AT+RX\r\n");
         Raz_Buffer1();
         Arme_Timer1(20);
         UART1_Write_CText("AT+RX\r\n");
         Delay_ms(100);
         while ((Flag_Timer1==0) && (DataReady1==0));
         Flag_Timer1=0;
         if(( DataReady1==1) || (Index1>2))
         {
         Flag_Timer1=0;
         CRLF3();
         UART3_Write_Text(buffer1);
         CRLF3();
         c1=RC1REG;
         }
         HC12_SET_Pin=1;
         Delay_ms(500);

     UART3_Write_CText(" Test registres DS18B20\r\n");

     Delay_ms(100);
     j=0;
     Ow_Reset(OWS_Pin);       // Onewire reset signal
      Delay_us(250);
     Ow_Write(OWS_Pin, 0x33); // Read ROM (if only one device)
      Delay_us(250);
     c1=Ow_Read(OWS_Pin); //  123456789012345678901234567890123456789012345678
     Delay_us(250);

     UART3_Write_CText(" Family Code : ");
     txt=&TEXTE[0];
      *(txt)=0;
     ByteToHex(c1,txt);
     UART3_Write_Text(txt);
     //Data: FamilyCo8 ID1= FF4715811603 CRC= 24
     UART3_Write_CText(" ID1= ");
     for (i=0;i<6;i++)
     {
     c1=  Ow_Read(OWS_Pin);
      Delay_us(250);
    // ID1[i]=c1;
     *(txt)=0;
     ByteToHex(c1,txt);
      UART3_Write_Text(txt);

     }
      UART3_Write_CText("  CRC= ");
     c1=  Ow_Read(OWS_Pin); // CRC
      *(txt)=0;
     ByteToHex(c1,txt);
     UART3_Write_Text(txt);
     CRLF3();


  j=0;
  k=0;

  HC12_SET_Pin=1;
  Delay_ms(100);

  while(1)
  {


     
      ch++;
      if (ch>3) ch=0;
     strConstRamCpy(CRam2,"AT+C000\r\n");
     cx=10+ ch<<1;

     if ((cx >=0) && (cx<100))
     {
          //AT+C010\r\n
          CANAL[6] =(cx/10)+48;
          CANAL[6]= (cx%10)+48;
        //  UART3_Write_CText("\r\n Modif Vitesse 1200 ->9600bds pour acces cde AT HC12\r\n");
        //  UART1_Init(9600);
        //  Delay_ms(200);
          HC12_SET_Pin=0;
          Delay_ms(500);
          UART3_Write_CText("\r\nEnvoi Cde Set channel :  ");
          UART3_Write_Text(CANAL);
          
          Arme_Timer1(10);  // 1 sec
          Raz_Buffer1();
          UART1_Write_Text(CANAL);
          Delay_ms(100);
          while ((Flag_Timer1==0) && (DataReady1==0));
          Flag_Timer1=0;
          //get response
          if(( DataReady1==1) || (Index1>7))
          { 
            UART3_Write_CText(" Retour: ");
            UART3_Write_Text(buffer1);
          //  CRLF3();
            p1=strstr(buffer1,"OK");
            if ( p1>0)  UART3_Write_CText(" Changement Canal OK \r\n");
             else  UART3_Write_CText(" PB sur Changement de Canal \r\n");
           }
           else
           {
           UART3_Write_CText(" NO response \r\n");
           }
          HC12_SET_Pin=1;
          Delay_ms(100);
          UART3_Write_CText(" l'ecoute du CANAL ");
          UART3_Write(CANAL[5]);UART3_Write(CANAL[6]);CRLF3();
          
          UART1_Write_CText("Waiting msg !\r\n");
     }
      Arme_Timer1(30);  // 3 sec
      Raz_Buffer1();
      Delay_ms(100);
      while ((Flag_Timer1==0) && (DataReady1==0));
      Flag_Timer1=0;
      if(( DataReady1==1) || (Index1>4))
      {
      // renvoi la commande  l'emetteur
      //CRLF3();UART3_Write_Text(buffer1); CRLF3();
      p1=buffer1;
     if ( (*(p1)=='L') && (*(p1+1)=='E') && (*(p1+2)=='D') && (*(p1+4)=='='))
      {
        cx=* (p1+3);
         switch (cx)
        {
          case 'R' :
             if (*(p1+5)=='1')  Led_Rouge=On;
             if (*(p1+5)=='0')  Led_Rouge=Off;
             // si ce n'est ni 1 ni 0..on fait rien
             break;
          case 'V' :
             if (*(p1+5)=='1')  Led_Verte=On;
             if (*(p1+5)=='0')  Led_Verte=Off;
             // si ce n'est ni 1 ni 0..on fait rien
             break;
          default:
           UART3_Write_CText("No comprendo \r\n");
            break ;
         }
        p1=0;
      }
       p1=strstr(buffer1,"Msg=");
      if (p1>0)
      {
       // limitation taille message sur 2 ligne de 16cars
       *(buffer1+32)=0;
        UART3_Write_CText("Msg reu : ");
        UART3_Write_Text(buffer1+4);
        CRLF3();*
       p1=0;
       }
     }
      if( DataReady1==2)
      {
       UART3_Write_CText(" PB debordement buffer1 \r\n");
       DataReady1=0;
      };
      

         Ow_Reset(OWS_Pin);              // Onewire reset signal
         Ow_Write(OWS_Pin, 0xCC);       // Issue command SKIP_ROM
         Ow_Write(OWS_Pin, 0x44);       // Issue command CONVERT_T
         Delay_us(250);
         Ow_Reset(OWS_Pin);
         Ow_Write(OWS_Pin, 0xCC);                   // Issue command SKIP_ROM
         Ow_Write(OWS_Pin, 0xBE);                   // Issue command READ_SCRATCHPAD    for only one sensor
         //Byte 0 and byte 1 of the scratchpad contain the LSB and the MSB of the temperature register
         temp =  Ow_Read(OWS_Pin);
         temp = (Ow_Read(OWS_Pin) << 8) + temp;
          //  Bytes 2 and 3 provide access to TH and TL registers
          // After the DS18B20 performs a temperature conversion, the temperature value is compared
          // to the user-defined twos complement alarm trigger values stored
          //  in the 1-byte TH and TL registers (see Figure 3).
          // The sign bit (S) indicates if the value is positive or negative:
          // for positive numbers S = 0 and for negative numbers S = 1.
          //  The TH and TL registers are nonvolatile (EEPROM) so they will retain data when the
          // device is powered down. TH and TL can be accessed through bytes 2 and 3 of the
          //  scratchpad as explained in the Memory section
         //TH1=
         cx= Ow_Read(OWS_Pin);
         //TL1=
         cx=  Ow_Read(OWS_Pin);
          //--- Format and display result
          txt=&TEXTE[0];
          *(txt)='C'; *(txt+1)='H';  // Numero de Canal en cours
          *(txt+2)=CANAL[5];
          *(txt+3)=CANAL[6];
          WordToStr(j,txt+4);  UART1_Write_Text(txt);
          UART3_Write_Text(txt);
          UART1_Write_CText("  DS#1= ");   // temperature DS18B20 concentrateur
          cx= DS18B20_Build_value(temp) ;
          UART1_Write_Text(txt);
          CRLF1();
          UART3_Write_CText("  DS#1= ");
          UART3_Write_Text(txt);
          CRLF3();

      Arme_Timer1(20);  // 2 sec
      while (Flag_Timer1==0);

     Raz_Buffer1();
     j++;
  } // while (1)
 }

/*
HC12 distant sur YAT terminal COM3  9600 bds ( ou 1200 bds)
AT
OK
AT+RX
OK+B9600
OK+RC010
OK+RP:+20dBm
OK+FU3

 Directory: C:\_MikroC\_MesProjets_MikroC\_HC12_Transceiver_433Mhz
 Projet : P18F26K22_Concentrateur_HC12.mcppi
 MCU  :18F26K22 Alim. =  3.6  5V
 Config : P18F26K22_FOSC_interne_16Mhz.cfgsch
 FOSC interne  16MHz via P18F26K22_FOSC_interne_16Mhz.cfgsch
 Port Hard UART1 19200,N,8,1 (RC6=TX RC7=RX)
 RA0=ADC  RA1=OWS sensor DS18B20
 Source P18F26K22_Concentrateur_HC12_190903.c
 Avec TX UART3 ASM sur RA2 output
 EEPROM non utilise

 Init I2C1 400Khz
 IT UART1 RC6 & Timer1<LF><CR>
 Init Setting  Canal 10 mode  FU3
 Lecture Setting  HC12 concentrateur sur Base PIC
 AT+RX

OK+B9600
OK+RC010
OK+RP:+20dBm
OK+FU3

 Test registres DS18B20
 Family Code : 28 ID1= AA0D82381401  CRC= CD

Envoi Cde Set channel :  AT+C013
 Retour: OK+C013
 Changement Canal OK
 l'ecoute du CANAL 13
CH13    0  DS#1=  27.00

Envoi Cde Set channel :  AT+C016
 Retour: OK+C016
 Changement Canal OK
 l'ecoute du CANAL 16
CH16    1  DS#1=  27.00

Envoi Cde Set channel :  AT+C010
 Retour: OK+C010
 Changement Canal OK
 l'ecoute du CANAL 10

Msg=Hello

Msg reu : Hello

CH10    2  DS#1=  27.00

Envoi Cde Set channel :  AT+C013
 Retour: OK+C013
 Changement Canal OK
 l'ecoute du CANAL 13
CH13    3  DS#1=  27.00

Envoi Cde Set channel :  AT+C016
 Retour: OK+C016
 Changement Canal OK
 l'ecoute du CANAL 16
CH16    4  DS#1=  27.00

Envoi Cde Set channel :  AT+C010
 Retour: OK+C010
 Changement Canal OK
 l'ecoute du CANAL 10

Msg=Hello

Msg reu : Hello

CH10    5  DS#1=  27.00

Envoi Cde Set channel :  AT+C013
 Retour: OK+C013
 Changement Canal OK
 l'ecoute du CANAL 13
CH13    6  DS#1=  27.00

-------------------------------------------
 Waiting msg !
Msg=Hello
CH10    2  DS#1=  27.00
Waiting msg !
Msg=Hello
CH10    5  DS#1=  27.00
---
Waiting msg !
LEDR=1
CH10    2  DS#1=  27.00
LEDR=0
Waiting msg !
LEDR=0
CH10    5  DS#1=  27.00
Waiting msg !
LEDV=1
CH10    8  DS#1=  27.00


*/